package com.meshsoftware.xml;

import java.io.IOException;
import org.xml.sax.InputSource;
import org.w3c.dom.Document;
import java.io.File;
import java.io.IOException;
import org.xml.sax.helpers.DefaultHandler;


/**
 * Class GenericParser provides an XML document validated
 * against the personal.xsd schema using any given parser.
 */


public interface GenericParser {
 
    public static String EXTERNAL_SCHEMA_LOCATION = "http://apache.org/xml/properties/schema/external-noNamespaceSchemaLocation";
    public static String NAMESPACES_FEATURE_ID = "http://xml.org/sax/features/namespaces";
    public static String NAMESPACE_PREFIXES_FEATURE_ID = "http://xml.org/sax/features/namespace-prefixes";
    public static String VALIDATION_FEATURE_ID = "http://xml.org/sax/features/validation";
    public static String SCHEMA_VALIDATION_FEATURE_ID = "http://apache.org/xml/features/validation/schema";
    public static String SCHEMA_FULL_CHECKING_FEATURE_ID = "http://apache.org/xml/features/validation/schema-full-checking";
    public static String DYNAMIC_VALIDATION_FEATURE_ID = "http://apache.org/xml/features/validation/dynamic";
    public static String STANDALONE_DOCUMENT = "http://apache.org/xml/features/nonvalidating/load-external-dtd";

    public static String SCHEMA_LOCATION = "http://localhost:8080/demo/AddRequest.xsd";


    // javax SAXParser
        /** Constants used for JAXP 1.2 */
    static final String JAXP_SCHEMA_LANGUAGE = "http://java.sun.com/xml/jaxp/properties/schemaLanguage";
    static final String W3C_XML_SCHEMA = "http://www.w3.org/2001/XMLSchema";
    static final String JAXP_SCHEMA_SOURCE = "http://java.sun.com/xml/jaxp/properties/schemaSource";

    public String getLoad();

    public void parse(String inp, boolean validate) throws Exception;

    // public void parser(String inp, String xsd_location, boolean validate);


    public void setXSD(String xsdUrl);

}

