package com.meshsoftware.tagext;

import javax.servlet.ServletRequest;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

import java.io.IOException; 

//XSLT validation
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.StringWriter;
import java.io.StringReader;
import java.io.FileReader;
import java.util.ResourceBundle;
import java.net.URL;
import javax.xml.transform.Transformer;
import javax.xml.transform.TransformerConfigurationException;
import javax.xml.transform.TransformerException;
import javax.xml.transform.TransformerFactory;
import javax.xml.transform.stream.StreamResult;
import javax.xml.transform.stream.StreamSource;


import com.meshsoftware.AddClient;

/**
 * JSP tag for Performing an add query through Web Services
 * @author Rajal Shah (rajal@meshsoftware.com)
 */

public class AddTag extends BaseTag {

    private final static String LOG_ID = "AddTag";

    public int doStartTag() {
      //	System.out.println("Inside dostartTag");  

	exceptionMessage = null;
	HttpSession session = pageContext.getSession();
	ServletRequest request = pageContext.getRequest();
	JspWriter out = pageContext.getOut();
	String requestXML = null;
	try {
	    out.println("<form method=\"post\" action=\"\"> ");
	    out.println("<table border=\"1\">");
	    out.println("<tr><td colspan=\"2\" align=\"center\"><b>Add</b></td></tr>");
	    out.println("<tr><td align=\"right\">Element A</td><td><input type=\"text\" name=\"a\" value=\"" + (request.getParameter("a") == null? "":request.getParameter("a")) + "\"></td></tr>");
	    out.println("<tr><td align=\"right\">Element B</td><td><input type=\"text\" name=\"b\" value=\"" + (request.getParameter("b") == null? "":request.getParameter("b")) + "\"></td></tr>");
	    out.println("<tr><td colspan=\"2\" align=\"center\"><br><br><input type=\"submit\" name=\"submit\" value=\"Add\" /></td></tr><tr><td colspan=\"2\" align=\"center\"><input type=\"reset\" /></td></tr>");
	    out.println("</table>");
	    out.println("</form>");

	    String submit = request.getParameter("submit");
	    if(submit != null && submit.equals("Add")) {
		requestXML = processRequest(request);
		String response = callWebService(requestXML, out);

		requestXML = xmlEncode(requestXML);
		response = xmlEncode(response);
	      out.println("<h3>Request XML</h3><p><pre>"+requestXML+"</pre></p>");
	      out.println("<h3>Response XML</h3><p><pre>"+response+"</pre></p>");
	    }
	} catch (Exception e) {
	    try {
	      out.println("<h3>Error</h3><p>"+e.getMessage()+"</p>\n");
	      if(requestXML != null) {
		  out.println("<h3>Request</h3><p><pre>"+xmlEncode(requestXML)+"</pre></p>");
	      }
	    } catch (IOException ioe) {
	      System.out.println("Unable to print error message:"+
				 e.getMessage()+":"+ioe.getMessage());
	    }
	    return SKIP_BODY;
	}

	    

	
	return EVAL_BODY_INCLUDE; //SKIP_BODY;
    }

    private String processRequest(ServletRequest request) throws Exception {

	StringBuffer sb = new StringBuffer();
	String value = null;
	sb.append("<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n");
	sb.append("<Calculator>\n");
	sb.append("\t<ClientInfo>\n");
	value = request.getParameter("applicationId");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<ApplicationId>"+xmlEncode(value)+"</ApplicationId>\n");
	}
	value = request.getParameter("userId");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<UserId>"+xmlEncode(value)+"</UserId>\n");
	}

	String DATE_FORMAT = "yyyy-MM-dd";
        String TIME_FORMAT = "HH:mm:ss";
	java.util.Calendar cal = java.util.Calendar.getInstance();
	java.text.SimpleDateFormat df = 
          new java.text.SimpleDateFormat(DATE_FORMAT);
	java.text.SimpleDateFormat tf = 
          new java.text.SimpleDateFormat(TIME_FORMAT);
	sb.append("\t\t<DateAndTime>"+
		  df.format(cal.getTime())+
		  "T" +
		  tf.format(cal.getTime())+
		  "</DateAndTime>\n");
	//	sb.append("\t\t<DateAndTime>2001-12-17T09:30:47-05:00</DateAndTime>\n");
	value = request.getParameter("transactionId");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<TransactionId>"+xmlEncode(value)+"</TransactionId>\n");
	}

	value = request.getParameter("debug");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<Debug>"+xmlEncode(value)+"</Debug>\n");
	}
	sb.append("\t</ClientInfo>\n");


	sb.append("\t<Add>\n");


	value = request.getParameter("a");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<ElementA>"+xmlEncode(value)+"</ElementA>\n");
	}
	value = request.getParameter("b");
	if(value != null) value = value.trim();
	if(value != null && !value.equals("")) {
	sb.append("\t\t<ElementB>"+xmlEncode(value)+"</ElementB>\n");
	}

	sb.append("\t</Add>\n");

	sb.append("</Calculator>\n");
	return( sb.toString());

    }


    private String callWebService(String requestXML, JspWriter out) 
      throws Exception {
	com.meshsoftware.AddClient client = new com.meshsoftware.AddClient();
	       long t1 = System.currentTimeMillis();
	       String response = client.add(requestXML);
	       long t2 = System.currentTimeMillis();
	       out.println("<h3>Round-trip Time</h3><table border=\"1\"><tr><td>Search Time</td><td>"+(t2-t1)+" millsec</td></tr></table>");

	
	//System.out.println(response);
	return response;
    }

    private String xmlEncode(String in) { 
	String[] delim = { "&", "<", "\"" };
	String[] values = { "&amp;", "&lt;", "&quot;" };

	java.lang.StringBuffer dest = new java.lang.StringBuffer(in);
	for(int i=0; i< delim.length; i++) {
	    String src = dest.toString();
	    dest = new java.lang.StringBuffer();
	    java.util.StringTokenizer st = 
		new java.util.StringTokenizer(src, delim[i], true);
	    while(st.hasMoreTokens()) {
		String token = st.nextToken();
		//		System.out.println("=> "+token);
		if(token.equals(delim[i])) {
		    dest.append(values[i]);
		} else {
		    dest.append(token);
		}
	    }
	    //	    System.out.println("===="+i+"==>"+dest);
	}
	return dest.toString();
    }
}
