package com.meshsoftware.tagext;

import java.io.*;
import javax.servlet.jsp.*;
import javax.servlet.http.*;
import javax.servlet.jsp.tagext.*;

/**
 * Base class for all tags that make Web Service calls
 * @author Rajal Shah (rajal@meshsoftware.com)
 */
public class BaseTag extends TagSupport {

  /**
   * The return code from the Web Service call
   */
  protected int returnCode          = -1;

  /**
   * The return message from the Web Service call
   */
  protected String returnMessage       = "";

  /**
   * If there is an exception during the Web Service call, this holds
   * the exception message. Must be set to null, if no exception.
   */
  protected String exceptionMessage = null;

  /**
   * Get method for the return code
   */
  public int getReturnCode (){
    return returnCode;
  }

  /**
   * Get method for the return message
   */
  public String getReturnMessage (){
    return returnMessage;
  }

  /**
   * Get method for the exception message
   */
  public String getExceptionMessage (){
    return exceptionMessage;
  }

}
